SystemOrganization addCategory: #'Orca-Testing'!

Object subclass: #OrcaMock
	instanceVariableNames: 'mockedObject receivedMessages stubbedMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMock class methodsFor: 'instance creation' stamp: 'hk 5/3/2011 07:46'!
for: anObject

	^ self new mockedObject: anObject! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 09:43'!
doesNotUnderstand: aMessage

	self receivedMessages add: aMessage.
	(self stubs: aMessage)
		ifTrue: [ ^ (self stubbedMessages at: aMessage selector) value ]
		ifFalse: [ aMessage sendTo: self mockedObject ].! !

!OrcaMock methodsFor: 'initialization' stamp: 'hk 5/3/2011 09:37'!
initialize

	self
		receivedMessages: OrderedCollection new;
		stubbedMessages: Dictionary new.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject
	^ mockedObject! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:46'!
mockedObject: anObject
	mockedObject := anObject! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:20'!
received: aMessage

	self assert: aMessage isSymbol.
	^ self received: aMessage atLeast: 1! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:10'!
received: aMessage atLeast: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size >= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:21'!
received: aMessage atMost: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size <= aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 08:11'!
received: aMessage times: aNumber

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each | each selector = aMessage]) size = aNumber! !

!OrcaMock methodsFor: 'expecting' stamp: 'hk 5/3/2011 10:20'!
received: aMessage withArgs: arguments

	self assert: aMessage isSymbol.
	^ (self receivedMessages select: [ :each |
		each selector = aMessage
		and: [ each arguments = arguments ]
		]) notEmpty! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages
	^ receivedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 07:58'!
receivedMessages: anObject
	receivedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:38'!
stub: aMessage

	self stubbedMessages at: aMessage put: nil.! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:40'!
stub: aMessage andReturn: aBlock

	self stubbedMessages at: aMessage put: aBlock.! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages
	^ stubbedMessages! !

!OrcaMock methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:37'!
stubbedMessages: anObject
	stubbedMessages := anObject! !

!OrcaMock methodsFor: 'stubbing' stamp: 'hk 5/3/2011 09:42'!
stubs: aMessage

	^ self stubbedMessages includesKey: aMessage selector! !

!OrcaMock methodsFor: 'mocking' stamp: 'hk 5/3/2011 07:57'!
unmock

	| temp |
	temp := self mockedObject.
	self mockedObject: nil.
	self become: temp.! !

TestCase subclass: #OrcaClientSideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 10:43'!
killFireFox

	CommandShell command: 'osascript -e ''tell application "Firefox" to quit'''
! !

!OrcaClientSideTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 10:48'!
runFireFox

	CommandShell command: 'open /Applications/Firefox.app --args http://foo.bar'! !

OrcaClientSideTest subclass: #OrcaFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 12:54'!
testError

	self foo.! !

!OrcaFailingTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 13:02'!
testFail

	self halt.
	self fail! !

OrcaClientSideTest subclass: #OrcaWidgetDomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:42'!
run

	self
		setUp;
		testText;
		testDomPresence;
		tearDown.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 14:14'!
setUp

	OrcaText new
		text: 'Hello World';
		addToWorld.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:38'!
tearDown

	Js Global alert value: 'I am done!!'.! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:43'!
testDomPresence

	self assert: (self hasElement: 'span').! !

!OrcaWidgetDomTest methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:43'!
testText

	self assert: (self hasText: 'Hello World').! !

TestCase subclass: #OrcaMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock
	^ mock! !

!OrcaMockTest methodsFor: 'accessing' stamp: 'hk 5/3/2011 09:45'!
mock: anObject
	mock := anObject! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
setUp

	self mock: (OrcaMock for: (OrderedCollection new)).! !

!OrcaMockTest methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 09:46'!
tearDown

	self mock: nil.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:11'!
testCleanInitialization

	self assert: self mock receivedMessages isEmpty.
	self assert: self mock stubbedMessages isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:50'!
testMessageForwarding

	self assert: (self mock stubbedMessages isEmpty).
	self mock add: true.
	self assert: self mock mockedObject size = 1! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:48'!
testMockedObject

	self assert: self mock mockedObject isCollection.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:19'!
testReceived

	self mock add: 1.
	self assert: (self mock received: #add:).
	self assert: (self mock received: #add: withArgs: { 1}).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:22'!
testReceivedAtLeast

	self deny: (self mock received: #add: atLeast: 1).
	self mock add: 1.
	self assert: (self mock received: #add: atLeast: 1).
	self deny: (self mock received: #add: atLeast: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedAtMost

	self assert: (self mock received: #add: atMost: 1).
	self mock
		add: 1;
		add: 2..
	self deny: (self mock received: #add: atMost: 1).
	self assert: (self mock received: #add: atMost: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:23'!
testReceivedTimes

	self deny: (self mock received: #add: times: 1).
	self mock add: 1.
	self assert: (self mock received: #add: times: 1).
	self deny: (self mock received: #add: times: 2).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:17'!
testStubReturnValue

	self mock stub: #add: andReturn: true.
	self assert: (self mock add: 1 = true).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:20'!
testStubReturnsNil

	self mock stub: #add:.
	self assert: ((self mock add: 1) = nil).
	self assert: self mock mockedObject isEmpty.! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 10:15'!
testStubbedMessages

	self mock stub: #add:.
	self deny: (self mock stubbedMessages isEmpty).! !

!OrcaMockTest methodsFor: 'testing' stamp: 'hk 5/3/2011 09:47'!
testUnmock

	self mock unmock.
	self assert: self mock isCollection.! !

OrcaWidget subclass: #OrcaTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Testing'!

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
isOrcaRootComponent
	
	^ true! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
orcaTitle
	
	^ 'Testing is fun'! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/3/2011 10:42'!
requiredClasses
	
	^ OrcaClientSideTest allSubclasses union: OrcaWidget allSubclasses! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:23'!
start

	^ self new addToWorld.! !

!OrcaTestRunner class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 15:06'!
uniquePath

	^ 'testing'! !

!OrcaTestRunner methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2011 16:41'!
initialize

	super initialize.
	self add: (OrcaText new text: 'Test Runner').
	OrcaWidgetDomTest new run.! !
